<!--Last Edit on Sep 21, 2023 -->
# Release Notes for NCID 1.15

[TOC]

## Overall System Requirements

> * Google libphonenumber integration
>> - libphonenumber version 7 or higher
>> - libicu version 67 or higher

> * ncid client and output modules
>> - TCL/TK version 8.6.6 or higher for ncid client and output modules

> * Operating System versions for NCID 1.12 and higher
>> If no minimum version is specified below, we're not aware of any limitations.  
>>
>> Unless specified, 32bit and higher processors are supported.
> 
>> - Cygwin is no longer supported
>> - FreeBSD
>> - Macintosh OS X* 10.9.5 (Mavericks) or higher  using XQuartz, Intel 64bit processors only
>> - Debian based OS
>>> - Debian Stretch (version 9) or higher
>>> - Raspbian* Stretch (version 9) or higher, 32bit processors only
>>> - Ubuntu
>> - RPM based OS
>>> - Fedora
>>> - Redhat
>>> - CentOS

>>> \* We're aware of operating system name changes but not all of our documentation has been updated yet:
>>>> \- Macintosh OS X became macOS as of June 13, 2016  
>>>> \- Raspbian became raspios (Raspberry Pi OS) as of May 29, 2020  


## NCID Distributions

> * SourceForge
> * Cygwin Windows package
> * FreeBSD package
> * Macintosh OS X package
> * Windows client installer
> * Debian based OS packages
>> * Debian
>> * raspios (Raspberry Pi)
>> * Ubuntu
> * RPM based OS packages
>> * Fedora
>> * Redhat
>> * CentOS

> ### SourceForge

          * NCID source package:           ncid-1.15-src.tar.gz

          * Cygwin Windows package:        not available

          * FreeBSD 64 bit package:        ncid-1.15-FreeBSD_install.sh

          * Macintosh 64 bit OS X package: not available

          * Windows client installer:      ncid-1.15-client_windows_setup.exe

          * Debian based OS packages
            ------------------------

                 Debian 64 bit packages:   ncid_1.15-1_amd64.deb
                                           ncid-gateways_1.15-1_amd64.deb

                 Debian no-arch packages:
                                           ncid-client_1.15-1_all.deb
                                           ncid-kpopup_1.15-1_all.deb
                                           ncid-mysql_1.15-1_all.deb
                                           ncid-mythtv_1.15-1_all.deb
                                           ncid-samba_1.15-1_all.deb
                                           ncid-speak_1.15-1_all.deb

                 raspios 32 bit packages: ncid_1.15-1_armhf.deb
                                           ncid-gateways_1.15-1_armhf.deb


          * RPM based OS packages
            ---------------------

                 RPM source package:       ncid-1.15-1.fc37.src.rpm

                 RPM 64 bit packages:      ncid-1.15-1.fc37.x86_64.rpm
                                           ncid-gateways-1.15-1.fc37.x86_64.rpm

                 RPM no-arch packages:     ncid-client-1.15-1.fc37.noarch.rpm
                                           ncid-kpopup-1.15-1.fc37.noarch.rpm
                                           ncid-mysql-1.15-1.fc37.noarch.rpm
                                           ncid-mythtv-1.15-1.fc37.noarch.rpm
                                           ncid-samba-1.15-1.fc37.noarch.rpm
                                           ncid-speak-1.15-1.fc37.noarch.rpm


> ### Cygwin Windows package

>> Not available. Cygwin does not provide the necessary library dependencies for libphonenumber.

> ### FreeBSD package

>> Available at FreshPorts.
>>
>>> https://www.freshports.org/comms/ncid/

> ### Macintosh OS X package

>> Not available. Library dependencies can only be resolved by compiling from source.

<!--
>> The version available at MacPorts is 0.83 which was released
>> October 2011. It is not currently maintained:
>>
>>> https://trac.macports.org/browser/trunk/dports/net/ncid/Portfile
>>
>> Use the version available at SourceForge.
-->

> ### Windows client installer

>> Use the version available at SourceForge.

> ### Debian based OS packages

>>#### Install from repositories:

>>> There are currently no known Debian repositories that host NCID.

<!--
>>> A new release of NCID is first available at Sourceforge. Some time later it is
   available at the Debian repositories.

>>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** deb packages.  The **ncid-gateways** can be installed
   if needed.

>> The apt-cache search command will show you the packages available:
>>
          apt-cache search ncid\*
-->
>> ####  Install from the files at SourceForge:
>>
    - Download the latest NCID DEB packages from SourceForge:
      ncid DEB Package          - server, extensions and tools
      ncid-client DEB Package   - client and default output modules
                                  (if using this client)
      ncid-gateways DEB Package - gateways (if using a gateway)
>>
    - Download any optional output modules wanted:
      ncid-MODULE DEB Package   - optional client output modules
>>
    - Install or Upgrade the packages using apt or apt-get (command line):
        * Install the NCID server and gateways:
          sudo apt install ./ncid-<version>_<processor>.deb
        * Install the client package and default modules:
          sudo apt install ./ncid-client-<version>_all.deb
        * Install any optional modules:
          sudo apt install ncid-<module>-<version>_all.deb
>>
    Notes:
        <version> would be something like: 1.15-1
        <processor> would be: i386, armhf, amd64
        <module> would be: kpopup, mysql, mythtv, samba, speak

>> #### Build a package for your specific Debian based OS or release

>>> <B>Required packages that must be installed:</B>
>>
          sudo apt install build-essential fakeroot vim rename
          sudo apt install libpcap-dev libpcre2-dev
          sudo apt install libphonenumber-dev libicu-dev libhidapi-dev
          sudo apt install libconfig-simple-perl libdata-hexdump-perl

>>> <B>Steps to build the install packages for raspios or ubuntu:</B>
>>
          export ID; ID=`sed '/^ID=/!d;s,^.*=,,' /etc/os-release`
          OS=`sed '/^VERSION_CODENAME=/!d;s,^.*=,,' /etc/os-release`
          [ "$ID" = "raspbian" ] && ID="raspios"
          tar -xzf ncid-1.15-src.tar.gz
          mv ncid ncid-1.15
          cd ncid-1.15
          fakeroot Debian/rules build
          fakeroot Debian/rules binary
          fakeroot Debian/rules clean
          cd ..
          ls | grep arm64 > /dev/null &&
          rename "s/arm64/${ID}_${OS}_arm64/" ${pkg}*_arm64.deb
          ls | grep armf > /dev/null &&
          rename "s/armhf/${ID}_${OS}_armhf/" ${pkg}*_armhf.deb
          ls | grep aarch64 > /dev/null &&
          rename "s/aarch64/${ID}_${OS}_aarch64/" ${pkg}*_arch64.deb


> ### RPM based OS packages

>>#### Install from repositories:

>>> A new release of NCID is first available at Sourceforge. Some time later it is available
   at the Fedora or other RPM repositories which includes the Rawhide repository for 
   the next Fedora release.

>> The install packages include the server, client, optional gateway packages and
   optional output module packages.  Normally you only need to install the **ncid**
   and **ncid-client** rpm packages.  The **ncid-gateways** can be installed
   if needed.

>> The dnf list command will show you the packages available:
>>
          dnf list ncid\*

>> If the above does not show version 1.15:
>>
          dnf --enablerepo=rawhide list ncid\*

>> If the rawhide repo is not installed:
>>
          dnf install fedora-release-rawhide

>> #### Build a package for your specific RPM based OS or release

>>> The rpmbuild package must be installed:
>>
          rpmbuild -tb ncid-1.15-src.tar.gz


>> If a dependency can not be resolved, you should try rebuilding packages:
>>
    - Download the latest NCID RPM packages from Sourceforge:
      ncid RPM Package          - server, extensions and tools
      ncid-gateways RPM Package - gateways (if using a gateway)
      ncid-client RPM Package   - client and default output modules
                                  (if using this client)
    - Download any optional output modules wanted:
      ncid-MODULE RPM Package  - optional client output modules
    - Install or Upgrade the packages using dnf
          * Install the NCID server and gateways:
            sudo dnf install ncid-<version>.fc37.x86_64.rpm
          * Install the client package and default modules:
            sudo dnf install ncid-client-<version>.fc37.noarch.rpm
          * Install any optional modules wanted:
            sudo dnf ncid-<module>-<version>.fc37.noarch.rpm
>>
    Notes:
        <version> would be something like: 1.15-1
        <module> would be: kpopup, mysql, mythtv, samba, speak


## Server Changes

> ncidd:

>- indicates, at log LEVEL1, if the support modem used is not on gateway lineid

> ncidd.conf:

>- added commented plugin scripts for the user to uncomment for use
## Service Files Changes

> None

## Server Extensions Changes

> hangup-postal-code: new
> 
> - searches the US postal codes for a state, commonwealth or territory abbreviation at the end of a Caller ID name

## Udev Files Changes (Linux Only)

> None

## Gateway Changes

> artech2ncid:

>- expanded options for when data is not sent to the ncidd server

> cideasy2ncid:

>- Updated

> wc2ncid:

>- fixed code to detect when the ncidd server stopped


## Client Changes

> ncid:

>- added getopt library to handle command line options

>- the Copy to Clipboard menu item can now copy a URL in the context menu for a history line

>- added a label for the types of themes displayed in the Themes menu

>- added log sttatements

>- Code improvements and fixes.

> ncid.conf:

>- corrected comments for LogEnable

## Client Output Module Changes

> None

## Client Plugins Changes

> None

## Client Desktop Changes

> None

## Setup Scripts Changes

> None

## Systemd Changes

> artech2ncid.service

>- Updated

> easy2ncid.service

>- Updated

## Tools Changes

> None

## Metadata Changes

> Updated

## Libcarrier Changes

> Updated

## Screenshots Changes

> None


## Documentation Changes

> Manual Pages:

>- new: hangup-postal-code.1

>- updated: artech2ncid.1

>- updated: hangup-combo.1

>- updated: ncid.1

>- updated: ncid_extensions.7

> User Manual:

>- updated


